require 'studio_game/player'
require 'studio_game/treasure_trove'


module StudioGame

  describe Player do

    before do
      $stdout = StringIO.new
    end

    context "mans are good" do
      before do
        @player = Player.new("larry", 150)
      end
      it "is capted" do
        @player.name.should == "Larry"
      end

      it "is healthed good" do
        @player.health.should == 150
      end
      it "is blamming good" do
        @player.blam
        @player.health.should == 140
      end
      it "is wooting good" do
        @player.w00t
        @player.health.should == 165
      end
      it "has a string representation" do  
        @player.found_treasure(Treasure.new(:hammer, 50))
        @player.found_treasure(Treasure.new(:hammer, 50))

        @player.to_s.should == "I'm Larry with health = 150, points = 100, and score = 250."
      end

      it "computes points as the sum of all treasure points" do
        @player.points.should == 0

        @player.found_treasure(Treasure.new(:hammer, 50))

        @player.points.should == 50

        @player.found_treasure(Treasure.new(:crowbar, 400))

        @player.points.should == 450

        @player.found_treasure(Treasure.new(:hammer, 50))

        @player.points.should == 500
      end 
      it "yields each found treasure and its total points" do
        @player.found_treasure(Treasure.new(:skillet, 100))
        @player.found_treasure(Treasure.new(:skillet, 100))
        @player.found_treasure(Treasure.new(:hammer, 50))
        @player.found_treasure(Treasure.new(:bottle, 5))
        @player.found_treasure(Treasure.new(:bottle, 5))
        @player.found_treasure(Treasure.new(:bottle, 5))
        @player.found_treasure(Treasure.new(:bottle, 5))
        @player.found_treasure(Treasure.new(:bottle, 5))

        yielded = []
        @player.each_found_treasure do |treasure|
          yielded << treasure
        end

        yielded.should == [
          Treasure.new(:skillet, 200), 
          Treasure.new(:hammer, 50), 
          Treasure.new(:bottle, 25)
        ]
      end

    end

    context "with a health greater than 100" do
      before do
        @player = Player.new("larry", 150)
      end

      it "is strong" do
        @player.should be_strong
      end
    end

    context "with a health of 100 or less" do
      before do
        @player = Player.new("larry", 100)
      end

      it "is wimpy" do
        @player.should_not be_strong
      end
    end
    # examples go here

    context "in a collection of players" do
      before do
        @player1 = Player.new("moe", 100)
        @player2 = Player.new("larry", 200)
        @player3 = Player.new("curly", 300)

        @players = [@player1, @player2, @player3]
      end

      it "is sorted by decreasing score" do
        @players.sort.should == [@player3, @player2, @player1]
      end
    end
  end
end
